package org.rhq.plugins.SolartisManagement;

import java.util.Set;
import java.util.*;
import org.rhq.core.domain.measurement.AvailabilityType;
import org.rhq.core.domain.measurement.MeasurementDataNumeric;
import org.rhq.core.domain.measurement.MeasurementReport;
import org.rhq.core.domain.measurement.MeasurementScheduleRequest;
import org.rhq.core.pluginapi.inventory.InvalidPluginConfigurationException;
import org.rhq.core.pluginapi.inventory.ResourceComponent;
import org.rhq.core.pluginapi.inventory.ResourceContext;
import org.rhq.core.pluginapi.measurement.MeasurementFacet;

public class SolartisManagementComponent implements ResourceComponent, MeasurementFacet {

	
	
	long loggedin;
	long loggedoff;
    long activeusers;
	long inactiveusers;
	
	
  int failedemails;
  int successemails;
  int totalemails;


	public AvailabilityType getAvailability()
	{
		if(false)
		{
			return AvailabilityType.DOWN;
		}
		return AvailabilityType.UP;
	}

	public void start(ResourceContext context) throws InvalidPluginConfigurationException, Exception
	{
	Random rand = new Random();

        loggedin        =	 rand.nextInt(50);
		loggedoff		=	rand.nextInt(30);
		activeusers		=	rand.nextInt(45);
		inactiveusers	=	rand.nextInt(60);


		failedemails=rand.nextInt(500);
		successemails=rand.nextInt(300);
		totalemails=(int)failedemails+(int)successemails;
	}

	public void stop() {}

	public void getValues(MeasurementReport report, Set<MeasurementScheduleRequest> metrics) throws Exception {

		for(MeasurementScheduleRequest request : metrics)
		{
		
		if(request.getName().equals("No of Users Loggedin"))
			{
				report.addData(new MeasurementDataNumeric(request,new Double(loggedin)));
				
			}
			if(request.getName().equals("No of Users Loggedoff"))
			{
				report.addData(new MeasurementDataNumeric(request,new Double(loggedoff)));
			}
			if(request.getName().equals("No of Currently active users"))
			{
				report.addData(new MeasurementDataNumeric(request, new Double(activeusers)));
			}
			if(request.getName().equals("No of Failed/Invalid Logins"))
			{
				report.addData(new MeasurementDataNumeric(request, new Double(inactiveusers)));
			}
		
		//Email details	
		
		
		
		
		
			if(request.getName().equals("No of Emails"))
			{
				report.addData(new MeasurementDataNumeric(request, new Double(totalemails)));
			}

			if(request.getName().equals("No of Failed Emails"))
			{
				report.addData(new MeasurementDataNumeric(request, new Double(failedemails)));
			}

			if(request.getName().equals("No of Successful Emails"))
			{
				report.addData(new MeasurementDataNumeric(request, new Double(successemails)));
			}

		}
	}
}